﻿'****************************************************************************************
'  TablePrint.dll の使い方
'****************************************************************************************
'[インストール、前準備]
' 1. TablePrint.dll を、exe と同じフォルダに置きます。
' 2. バーコードを印刷する場合は、DotNetBarcode.dll も同様に、exe と同じフォルダに置きます。
' 3. 開発時には、TablePrint.dll,DotNetBarcode.dll を、参照の追加で、開発環境に登録します。
'     プロジェクト -> 参照の追加 
'
'[開発手順]
' 4. TablePrint クラスのインスタンスを作成します。
'    _TablePrint = New TablePrint.ClsTablePrint()
' 5. 下記のサンプルプログラム、ドキュメントを参考にして、プログラムを作成します。
'     印刷手順は、全て、同じです。
'     データの種類によって、印刷データをセットする関数が異なるのみです。
'     a) 必須：_TablePrint.印刷初期化("")        '初期化
'     b) 任意：様々な印刷オプションを指定します。
'     c) 必須：_TablePrint.SetDateFmDGV(dgv)     '<<< 印刷データのセット。 データの種類によって、呼び出す関数が異なっている。
'     d) 必須：_TablePrint.Preview("")           'プレビューの実行。
' 
'
'[運用時]
' 6. 作成したexeと同じフォルダに、TablePrint.dll,DotNetBarcode.dll を配置します。
'
'［注意］
'バーコード印刷未対応版の場合、DotNetBarcode.dll は不要です。




Imports TablePrint
Public Class FrmTest印刷
     '****************************************************************************************
    '  プライベート変数定義
    '****************************************************************************************
    Private _TablePrint As TablePrint.ClsTablePrint
    Private _CnOleDB As OleDb.OleDbConnection
    Private _CnOdbc As Odbc.OdbcConnection
    Private _SQLSmp01 As String = "Select * from  Customers"
    Private _SQLSmp02 As String = "Select * from  Orders  order by CustomerID,ProductID "

    '****************************************************************************************
    '
    '【ODBC 接続文字列例】
    ' DSN          DSN=[データソース名]; UID=[ユーザID]; PWD=[パスワード]
    ' AccessMdb    Driver={Microsoft Access Driver (*.mdb)};DBQ=[MDBファイルのファイルパス];Pwd=[パスワード]
    ' AccessAccDB  Driver={Microsoft Access Driver (*.mdb, *.accdb)};DBQ=[AccDBファイルのファイルパス];Pwd=[パスワード]
    ' SQLServer    Driver={SQL Server};Server=[接続先サーバ];Uid=[ユーザID];Pwd=[パスワード];Database=[データベース]
    ' MySQL        Driver={mySQL ODBC x.xx Driver};Server=[接続先サーバ];Port=3306;Option=131072;Stmt=SET CHARACTER SET SJIS;Database=[データベース];Uid=[ユーザID];Pwd=[パスワード]
    ' ORACLE       Driver={Oracle in Oraxxxxxx};DBQ=[サービス名];UID=[ユーザID];PWD=[パスワード] 
    ' PostgreSQL   Driver={PostgreSQL};[Server=サーバ名];Database=[データベース];UID=[ユーザID];PWD=[パスワード];Port=5432;
    '    注）ドライバー名は、バージョンによって頻繁に変更になるので、ODBCデータソースアドミニストレーター  に表示されているドライバ名を確認のこと。
    '            コントロールパネル -> 管理ツール -> データソース(ODBC)
    '    注）AccessMdb,SQLServer 以外は、ODBCドライバーをインストールする必要あり。
    '    注）ODBCドライバは、バグが多いので、うまく動くバージョンを使用すること。
    '    注）上記、接続文字列を使ってオープンすれば、DSN を登録する必要はない。
    '
    '****************************************************************************************
    Private Sub FrmTest印刷_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim wkDBfile As String = Application.StartupPath & "\atsmp.mdb"
        Dim wkCnStrOledb As String = "PROVIDER=Microsoft.Jet.OLEDB.4.0;Data Source=" & wkDBfile
        Dim wkCnStrOdbc As String = "Driver={Microsoft Access Driver (*.mdb)};DBQ=" & wkDBfile

        '【印刷用クラス(このDLL)のインスタンスの作成】
        _TablePrint = New TablePrint.ClsTablePrint()
        _CnOdbc = New Odbc.OdbcConnection(wkCnStrOdbc)
        _CnOdbc.ConnectionString = wkCnStrOdbc
        _CnOdbc.Open()

        _CnOleDB = New OleDb.OleDbConnection(wkCnStrOledb)
        _CnOleDB.ConnectionString = wkCnStrOledb
        _CnOleDB.Open()

        LblVersion.Text = "TeblePrintDLL Version= " & ClsTablePrint.ClsVersion
        lblBarCodeLicense.Text = ClsTablePrint.BarCodeLicense
    End Sub


    '****************************************************************************************
    '  解除キーを登録する画面を表示する。
    '****************************************************************************************
    Private Sub btn解除キー登録_Click(sender As System.Object, e As System.EventArgs) Handles btn解除キー登録.Click
        _TablePrint.解除キー登録画面表示("TablePrint.dll の解除キー登録", "TablePrint.DLL    の解除キーを登録します。")
    End Sub
    '****************************************************************************************
    ' 用紙サイズやマージン等の印刷設定を行う画面を表示する。
    '****************************************************************************************
    Private Sub btn印刷設定_Click(sender As System.Object, e As System.EventArgs) Handles btn印刷設定.Click
        _TablePrint.印刷設定()
    End Sub
    '****************************************************************************************
    ' DataGridView に表示されている内容を印刷する。
    '
    '     印刷手順は、全て、同じです。
    '     データの種類によって、印刷データをセットする関数が異なるのみです。
    '     a) 必須：_TablePrint.印刷初期化("")        '初期化
    '     b) 任意：様々な印刷オプションを指定します。
    '     c) 必須：_TablePrint.SetDateFmDGV(dgv)     '<<< 印刷データのセット。 データの種類によって、呼び出す関数が異なっている。
    '     d) 必須：_TablePrint.Preview("")           'プレビューの実行。
    '
    '****************************************************************************************
    Private Sub btnデータグリッドを印刷_Click(sender As System.Object, e As System.EventArgs) Handles btnデータグリッドを印刷.Click
        _TablePrint.印刷初期化("")                              '必須：印刷前に初期化します。
        _TablePrint.印刷列タイトル("")                          '任意：指定されていれば、グリッドの列タイトルより、この情報が優先する。
        _TablePrint.印刷列フォーマット("4/c/0/0 , 6/c/1/2")     '任意：指定されていれば、グリッドのデータ型より、こちらが優先する。
        '                                                    '        注）列フォーマット指定の文字列は、サンプル画面の『列書式 作成』画面を使えば簡単です。
        _TablePrint.用紙設定 = "行高=5"                         '任意：用紙設定等を行います。
        _TablePrint.SetDate(dgv)                                '必須：DataGridViewから、印刷データをセットします。
        _TablePrint.Preview("データグリッドビューの印刷例です") '必須：印刷内容を、プレビューします。（同時に、表のタイトルを指定します。）
    End Sub
    '****************************************************************************************
    '  ＣＳＶをセットして印刷する。
    '****************************************************************************************
    Private Sub btnPreview_Click(sender As System.Object, e As System.EventArgs) Handles btnPreview.Click
        '一行おきの背景色を変更します。
        Dim _BackColor As System.Drawing.Brush = Brushes.PowderBlue
        _TablePrint.Brush = _BackColor


        _TablePrint.印刷初期化(TestTitle)                    '必須：初期化と、表の列タイトルを指定。
        _TablePrint.印刷列フォーマット("2/i/1/0, 3/c/1/2")   '任意：各列の印刷フォーマットを指定
        '                                                    '        注）列フォーマット指定の文字列は、サンプル画面の『列書式 作成』画面を使えば簡単です。
        _TablePrint.用紙設定 = "行高=5"                      '任意：用紙設定で、行の高さを明示的に指定。（指定しない場合は、フォント高さで自動調整）
        testDataSet()                                        '必須：ＣＳＶより、印刷データをセットする。（詳細な記述は、関数内を参照）
        _TablePrint.Preview("ＣＳＶデータの印刷例です")      '必須：
    End Sub


    '****************************************************************************************
    ' バーコード印刷のサンプル
    '****************************************************************************************
    Private Sub btnPreview01_Click(sender As System.Object, e As System.EventArgs) Handles btnPreview01.Click
        If _TablePrint.BarCodeFG = False Then
            MsgBox("このDLLは、バーコード印刷には、未対応です。")
            Exit Sub
        End If

        _TablePrint.印刷初期化("JAN8,JAN8, T01, Jan13, Jan13, T04,Code39,Code39")  '必須：初期化と、表の列タイトルを指定。
        '_TablePrint.印刷列フォーマット("2/B8/1/0, 5/B13/1/0,8/B39/1/0")           '任意：バーコードの場合、データタイプに、B8,B13,B39,QR を指定します。
        _TablePrint.印刷列フォーマット("2/B8, 5/B13,8/B39")                        '任意：バーコードの場合、データタイプに、B8,B13,B39,QR を指定します。
        '                                                                                 注意）QR は、１ピクセル単位、２ピクセル単位と飛び飛びの大きさで印刷されます。
        '                                                                                       必要な印刷領域が確保されていないと、印刷されません。
        '                                                                                       従って、行高さは、充分に確保して下さい。
        _TablePrint.用紙設定 = "行高=15"                                           '任意：バーコードの為に、行の高さを高めにセットしています。
        test01DataSet()                                                            '必須：ＣＳＶより、印刷データをセットする。（詳細な記述は、関数内を参照）
        _TablePrint.Preview("バーコードの印刷例です")                              '必須：
    End Sub

    '****************************************************************************************
    ' ＯＤＢＣ接続コネクションを指定しての印刷。
    '
    '****************************************************************************************
    Private Sub btnPreviewDBODBC_Click(sender As System.Object, e As System.EventArgs) Handles btnPreviewDBODBC.Click
        '一行おきの背景色を変更します。
        Dim _BackColor As System.Drawing.Brush = Brushes.Wheat
        _TablePrint.Brush = _BackColor


        _TablePrint.印刷初期化()                                      '必須：
        _TablePrint.印刷列フォーマット("1/s/0/0,4/c/0/0 , 6/c/0/2")   '任意：
        '                                                    '        注）列フォーマット指定の文字列は、サンプル画面の『列書式 作成』画面を使えば簡単です。
        _TablePrint.用紙設定 = "行高=5"                               '任意：
        _TablePrint.SetDate(_CnOdbc, _SQLSmp02)                       '必須：ODBCのコネクションと、抽出用SQL文を与えて、抽出結果を印刷する。
        _TablePrint.Preview("ＯＤＢＣ接続 ＤＢの印刷例です")          '必須：
    End Sub

    '****************************************************************************************
    ' ＯｌｅＤＢ接続コネクションを指定しての印刷。
    '   注意）OleDBは、出来るだけ、使わないように。
    '         理由：将来、このインターフェースは、廃止され、ODBC に統一される予定。
    '               使えるDBが限られている。Access と、SQLServer 以外では使えない。
    '****************************************************************************************
    Private Sub btnPreviewDBOledb_Click(sender As System.Object, e As System.EventArgs) Handles btnPreviewDBOledb.Click
        '一行おきの背景色を変更します。
        Dim _BackColor As System.Drawing.Brush = Brushes.Thistle
        _TablePrint.Brush = _BackColor


        _TablePrint.印刷初期化("")                                  '必須：
        _TablePrint.印刷列フォーマット("4/c/0/0 , 6/c/1/2")         '任意：
        '                                                    '        注）列フォーマット指定の文字列は、サンプル画面の『列書式 作成』画面を使えば簡単です。
        _TablePrint.用紙設定 = "行高=5"                             '任意：
        _TablePrint.SetDate(_CnOleDB, _SQLSmp02)                    '必須：OleDbのコネクションと、抽出用SQL文を与えて、抽出結果を印刷する。
        _TablePrint.Preview("OleDB接続 DBの印刷例です")             '必須：
    End Sub

    '****************************************************************************************
    '  データテーブルの内容を印刷
    '****************************************************************************************
    Private Sub btnデータグリッドにデータ表示_Click(sender As System.Object, e As System.EventArgs) Handles btnデータグリッドにデータ表示.Click
        Dim pDataTable As DataTable = Nothing
        '--------------------------------------------
        'DBより、データテーブルに値を取得し、データグリッドビューに表示する。
        '--------------------------------------------
        Dim rt As Integer = ODBCx_GetToDT(_CnOdbc, _SQLSmp02, pDataTable)
        dgv.DataSource = pDataTable
        dgv.AutoGenerateColumns = False                                 ' 自動的に列が追加されないようにする
        dgv.AllowUserToAddRows = False                                  ' 一番下にユーザーが新しい行を追加するための行（行ヘッダーに「*」のある行、新規行）が表示されます。この行が表示されないようにする

        '--------------------------------------------
        ' データテーブルの内容を印刷する。
        '--------------------------------------------
        _TablePrint.印刷初期化("")                              '必須：
        _TablePrint.印刷列タイトル("")                          '任意：指定されていれば、グリッドの列タイトルより、この情報が優先する。
        _TablePrint.印刷列フォーマット("4/c/0/0 , 6/c/1/2")     '任意：指定されていれば、グリッドのデータ型より、こちらが優先する。
        _TablePrint.用紙設定 = "行高=5"                         '任意：
        _TablePrint.SetDate(pDataTable)                         '必須：データテーブルを指定して、印刷データをセットする。
        _TablePrint.Preview("データテーブルの印刷例です")       '必須：印刷内容を、プレビューします。
    End Sub

    '****************************************************************************************
    ' 
    '****************************************************************************************
    Private Sub btn列書式作成_Click(sender As System.Object, e As System.EventArgs) Handles btn列書式作成.Click
        Frm列フォーマット作成.ShowDialog()
    End Sub

    '****************************************************************************************
    '****************************************************************************************
    '****************************************************************************************
    ' 以下は補助プログラムです。
    '****************************************************************************************
    '****************************************************************************************
    '****************************************************************************************

    '****************************************************************************************
    '  テストデータセット         ＤＢより、データテーブルへ
    '****************************************************************************************
    Private Function ODBCx_GetToDT(ByVal pCn As Odbc.OdbcConnection, ByVal pSQL As String, ByRef pDataTable As DataTable) As Integer
        Dim ODBCDA As Odbc.OdbcDataAdapter

        Try
            ODBCDA = New Odbc.OdbcDataAdapter(pSQL, pCn)
            pDataTable = New DataTable
            ODBCDA.Fill(pDataTable)

            If Not ODBCDA Is Nothing Then ODBCDA.Dispose()
            Return (1)
        Catch ex As Exception
            MsgBox("データアダプターへの読込失敗 on ODBCx_GetToDT" + vbCrLf + pSQL + vbCrLf + ex.Message)
            Return (-1)
        End Try

    End Function

    '****************************************************************************************
    '  テストデータセット
    '****************************************************************************************
    Private Sub DGVtestDataset()
        dgv.Rows.Add(TestData00)
        dgv.Rows.Add(TestData01)
    End Sub

    '****************************************************************************************
    '  テストデータセット
    '****************************************************************************************
    Private Sub testDataSet()

        _TablePrint.SetDataFmCSV(TestData00)
        _TablePrint.SetDataFmCSV(TestData01)
        _TablePrint.SetDataFmCSV(TestData02)
        _TablePrint.SetDataFmCSV(TestData03)
        _TablePrint.SetDataFmCSV(TestData04)
        _TablePrint.SetDataFmCSV(TestData05)
        _TablePrint.SetDataFmCSV(TestData06)
        _TablePrint.SetDataFmCSV(TestData07)
        _TablePrint.SetDataFmCSV(TestData08)
        _TablePrint.SetDataFmCSV(TestData09)

        _TablePrint.SetDataFmCSV(TestData10)
        _TablePrint.SetDataFmCSV(TestData11)
        _TablePrint.SetDataFmCSV(TestData12)
        _TablePrint.SetDataFmCSV(TestData13)
        _TablePrint.SetDataFmCSV(TestData14)
        _TablePrint.SetDataFmCSV(TestData15)
        _TablePrint.SetDataFmCSV(TestData16)
        _TablePrint.SetDataFmCSV(TestData17)
        _TablePrint.SetDataFmCSV(TestData18)
        _TablePrint.SetDataFmCSV(TestData19)

        _TablePrint.SetDataFmCSV(TestData20)
        _TablePrint.SetDataFmCSV(TestData21)
        _TablePrint.SetDataFmCSV(TestData22)
        _TablePrint.SetDataFmCSV(TestData23)
        _TablePrint.SetDataFmCSV(TestData24)
        _TablePrint.SetDataFmCSV(TestData25)
        _TablePrint.SetDataFmCSV(TestData26)
        _TablePrint.SetDataFmCSV(TestData27)
        _TablePrint.SetDataFmCSV(TestData28)
        _TablePrint.SetDataFmCSV(TestData29)

        _TablePrint.SetDataFmCSV(TestData30)
        _TablePrint.SetDataFmCSV(TestData31)
        _TablePrint.SetDataFmCSV(TestData32)
        _TablePrint.SetDataFmCSV(TestData33)
        _TablePrint.SetDataFmCSV(TestData34)
        _TablePrint.SetDataFmCSV(TestData35)
        _TablePrint.SetDataFmCSV(TestData36)
        _TablePrint.SetDataFmCSV(TestData37)
        _TablePrint.SetDataFmCSV(TestData38)
        _TablePrint.SetDataFmCSV(TestData39)

        _TablePrint.SetDataFmCSV(TestData40)
        _TablePrint.SetDataFmCSV(TestData41)
        _TablePrint.SetDataFmCSV(TestData42)
        _TablePrint.SetDataFmCSV(TestData43)
        _TablePrint.SetDataFmCSV(TestData44)
        _TablePrint.SetDataFmCSV(TestData45)
        _TablePrint.SetDataFmCSV(TestData46)
        _TablePrint.SetDataFmCSV(TestData47)
        _TablePrint.SetDataFmCSV(TestData48)
        _TablePrint.SetDataFmCSV(TestData49)
    End Sub

    '****************************************************************************************
    '  テストデータセット
    '****************************************************************************************
    Private Sub test01DataSet()
        _TablePrint.SetDataFmCSV(Test02Data00)
        _TablePrint.SetDataFmCSV(Test02Data01)
        _TablePrint.SetDataFmCSV(Test02Data02)
        _TablePrint.SetDataFmCSV(Test02Data03)
        _TablePrint.SetDataFmCSV(Test02Data04)
        _TablePrint.SetDataFmCSV(Test02Data05)
        _TablePrint.SetDataFmCSV(Test02Data06)
        _TablePrint.SetDataFmCSV(Test02Data07)
        _TablePrint.SetDataFmCSV(Test02Data08)
        _TablePrint.SetDataFmCSV(Test02Data09)
        _TablePrint.SetDataFmCSV(Test02Data10)
    End Sub

    '****************************************************************************************
    '
    '****************************************************************************************
    Public TestTitle As String = "Ti0, T01, T02, Title03, Title04, 行タイトル05, 行タイトル06, 行タイトル07, 行タイトル08, 行タイトル09, 他10, 意11, 戸12, ル13"
    Public TestColAlign As Integer() = {0, 1, 2, 0, 1, 2, 0, 1, 2, 0, 1, 2, 0, 1}

    Public TestData00 As String() = {"b", "1000", "1234.46", "bbbb", "bbbbb", "b", "bb", "bbb", "bbbb", "bbbbb", "bbbbbb", "bbbbbb", "b", "bb"}
    Public TestData01 As String() = {"0", "1", "12.34", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13"}
    Public TestData02 As String() = {"０", "1", "12.34", "３", "４", "５", "６", "７", "８", "９", "１０", "１１", "１２", "１３"}
    Public TestData03 As String() = {"a", "1", "12.34", "aaaa", "aaaaa", "aaaaaa", "aaaaaaa", "aaaaaaaa", "aaaaaaaaa", "aaaaaaaaaa", "aaaaaaaaaaa", "aaaaaaaaaaaa", "aaaaaaaaaaaa", "aaaaaaaaaaaaa"}
    Public TestData04 As String() = {"", "1", "12.34", "", "", "", "", "", "", "", "", "", "", ""}
    Public TestData05 As String() = {"あ", "1", "12.34", "ああああ", "あああああ", "あ", "ああ", "あああ", "ああああ", "あああああ", "ああああああ", "あああああああ", "ああああああああ", "あ"}
    Public TestData06 As String() = {"cc", "1", "12.34", "c", "cc", "ccc", "cccc", "ccccc", "c", "cc", "ccc", "c", "cc", "ccc"}
    Public TestData07 As String() = {"い", "1", "12.34", "いいいい", "いいいいい", "い", "いい", "いいい", "いいいい", "いいいいい", "い", "いい", "いいい", "い"}
    Public TestData08 As String() = {"d", "1", "12.34", "dddd", "ddddd", "d", "dd", "ddd", "dddd", "", "d", "dd", "ddd", "dddd"}
    Public TestData09 As String() = {"", "1", "12.34", "fff", "ffff", "fffff", "ffffff", "f", "ff", "fff", "ffff", "fffff", "fffff", "ffff"}


    Public TestData10 As String() = {"0", "1", "12.34", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13"}
    Public TestData11 As String() = {"０", "1", "12.34", "３３３", "４４", "５５５", "６６６６６６６６６６６６６６６", "７７７７７７７７７７７７７７７８", "８８８８８８８８８８８８８８８９９", "９", "１０", "１１", "１２", "１３"}
    Public TestData12 As String() = {"a", "1", "12.34", "aaaa", "aaaaa", "aaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaaaaa"}
    Public TestData13 As String() = {"", "1", "12.34", "", "", "", "", "", "", "", "", "", "", ""}
    Public TestData14 As String() = {"あ", "1", "12.34", "ああああ", "あああああ", "あ", "ああ", "あああ", "ああああ", "あああああ", "ああああああ", "あああああああ", "ああああああああ", "あ"}
    Public TestData15 As String() = {"b", "1", "12.34", "bbbb", "bbbbb", "b", "bb", "bbb", "bbbb", "bbbbb", "bbbbbb", "bbbbbb", "b", "bb"}
    Public TestData16 As String() = {"cc", "1", "12.34", "c", "cc", "ccc", "cccc", "ccccc", "c", "cc", "ccc", "c", "cc", "ccc"}
    Public TestData17 As String() = {"い", "1", "12.34", "いいいい", "いいいいい", "い", "いい", "いいい", "いいいい", "いいいいい", "い", "いい", "いいい", "い"}
    Public TestData18 As String() = {"d", "1", "12.34", "dddd", "ddddd", "d", "dd", "ddd", "dddd", "", "d", "dd", "ddd", "dddd"}
    Public TestData19 As String() = {"", "1", "12.34", "fff", "ffff", "fffff", "ffffff", "f", "ff", "fff", "ffff", "fffff", "fffff", "ffff"}


    Public TestData20 As String() = {"0", "1", "12.34", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13"}
    Public TestData21 As String() = {"０", "1", "12.34", "３", "４", "５", "６", "７", "８", "９", "１０", "１１", "１２", "１３"}
    Public TestData22 As String() = {"a", "1", "12.34", "aaaa", "aaaaa", "aaaaaa", "aaaaaaa", "aaaaaaaa", "aaaaaaaaa", "aaaaaaaaaa", "aaaaaaaaaaa", "aaaaaaaaaaaa", "aaaaaaaaaaaa", "aaaaaaaaaaaaa"}
    Public TestData23 As String() = {"", "1", "12.34", "", "", "", "", "", "", "", "", "", "", ""}
    Public TestData24 As String() = {"あ", "1", "12.34", "ああああ", "あああああ", "あ", "ああ", "あああ", "ああああ", "あああああ", "ああああああ", "あああああああ", "ああああああああ", "あ"}
    Public TestData25 As String() = {"b", "1", "12.34", "bbbb", "bbbbb", "b", "bb", "bbb", "bbbb", "bbbbb", "bbbbbb", "bbbbbb", "b", "bb"}
    Public TestData26 As String() = {"cc", "1", "12.34", "c", "cc", "ccc", "cccc", "ccccc", "c", "cc", "ccc", "c", "cc", "ccc"}
    Public TestData27 As String() = {"い", "1", "12.34", "いいいい", "いいいいい", "い", "いい", "いいい", "いいいい", "いいいいい", "い", "いい", "いいい", "い"}
    Public TestData28 As String() = {"d", "1", "12.34", "dddd", "ddddd", "d", "dd", "ddd", "dddd", "", "d", "dd", "ddd", "dddd"}
    Public TestData29 As String() = {"", "1", "12.34", "fff", "ffff", "fffff", "ffffff", "f", "ff", "fff", "ffff", "fffff", "fffff", "ffff"}

    Public TestData30 As String() = {"0", "1", "12.34", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13"}
    Public TestData31 As String() = {"０", "1", "12.34", "３３３", "４４", "５５５", "６６６６６６６６６６６６６６６", "７７７７７７７７７７７７７７７８", "８８８８８８８８８８８８８８８９９", "９", "１０", "１１", "１２", "１３"}
    Public TestData32 As String() = {"a", "1", "12.34", "aaaa", "aaaaa", "aaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaaaaa"}
    Public TestData33 As String() = {"", "1", "12.34", "", "", "", "", "", "", "", "", "", "", ""}
    Public TestData34 As String() = {"あ", "1", "12.34", "ああああ", "あああああ", "あ", "ああ", "あああ", "ああああ", "あああああ", "ああああああ", "あああああああ", "ああああああああ", "あ"}
    Public TestData35 As String() = {"b", "1", "12.34", "bbbb", "bbbbb", "b", "bb", "bbb", "bbbb", "bbbbb", "bbbbbb", "bbbbbb", "b", "bb"}
    Public TestData36 As String() = {"cc", "1", "12.34", "c", "cc", "ccc", "cccc", "ccccc", "c", "cc", "ccc", "c", "cc", "ccc"}
    Public TestData37 As String() = {"い", "1", "12.34", "いいいい", "いいいいい", "い", "いい", "いいい", "いいいい", "いいいいい", "い", "いい", "いいい", "い"}
    Public TestData38 As String() = {"d", "1", "12.34", "dddd", "ddddd", "d", "dd", "ddd", "dddd", "", "d", "dd", "ddd", "dddd"}
    Public TestData39 As String() = {"", "1", "12.34", "fff", "ffff", "fffff", "ffffff", "f", "ff", "fff", "ffff", "fffff", "fffff", "ffff"}

    Public TestData40 As String() = {"0", "1", "12.34", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13"}
    Public TestData41 As String() = {"０", "1", "12.34", "３３３", "４４", "５５５", "６６６６６６６６６６６６６６６", "７７７７７７７７７７７７７７７８", "８８８８８８８８８８８８８８８９９", "９", "１０", "１１", "１２", "１３"}
    Public TestData42 As String() = {"a", "1", "12.34", "aaaa", "aaaaa", "aaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaaaa", "xxxxxxxxxxxxxxxxxxxxxxxxaaaaaaaaaaaaa"}
    Public TestData43 As String() = {"", "1", "12.34", "", "", "", "", "", "", "", "", "", "", ""}
    Public TestData44 As String() = {"あ", "1", "12.34", "ああああ", "あああああ", "あ", "ああ", "あああ", "ああああ", "あああああ", "ああああああ", "あああああああ", "ああああああああ", "あ"}
    Public TestData45 As String() = {"b", "1", "12.34", "bbbb", "bbbbb", "b", "bb", "bbb", "bbbb", "bbbbb", "bbbbbb", "bbbbbb", "b", "bb"}
    Public TestData46 As String() = {"cc", "1", "12.34", "c", "cc", "ccc", "cccc", "ccccc", "c", "cc", "ccc", "c", "cc", "ccc"}
    Public TestData47 As String() = {"い", "1", "12.34", "いいいい", "いいいいい", "い", "いい", "いいい", "いいいい", "いいいいい", "い", "いい", "いいい", "い"}
    Public TestData48 As String() = {"d", "1", "12.34", "dddd", "ddddd", "d", "dd", "ddd", "dddd", "", "d", "dd", "ddd", "dddd"}
    Public TestData49 As String() = {"", "1", "12.34", "fff", "ffff", "fffff", "ffffff", "f", "ff", "fff", "ffff", "fffff", "fffff", "ffff"}


    Public Test02Title As String = "JAN8,JAN8, T01, Jan13, Jan13, T04,Code39,Code39"
    Public Test02ColAlign As Integer() = {0, 0, 0, 0, 0, 0}
    '                                  1          2          3       4               5               6       7                  8      
    Public Test02Data00 As String() = {"2345678", "2345678", "    ", "234567890123", "234567890123", "    ", "1abcdefghijklmn", "1abcdefghijklmn"}
    Public Test02Data01 As String() = {"2345679", "2345679", "    ", "234567890124", "234567890124", "    ", "2abcdefghijklmn", "2abcdefghijklmn"}
    Public Test02Data02 As String() = {"2345670", "2345670", "    ", "234567890125", "234567890125", "    ", "3abcdefghijklmn", "3abcdefghijklmn"}
    Public Test02Data03 As String() = {"2345671", "2345671", "    ", "234567890126", "234567890126", "    ", "4abcdefghijklmn", "4abcdefghijklmn"}
    Public Test02Data04 As String() = {"2345672", "2345672", "    ", "234567890127", "234567890127", "    ", "5abcdefghijklmn", "5abcdefghijklmn"}
    Public Test02Data05 As String() = {"2345673", "2345673", "    ", "234567890128", "234567890128", "    ", "6abcdefghijklmn", "6abcdefghijklmn"}
    Public Test02Data06 As String() = {"2345674", "2345674", "    ", "234567890129", "234567890129", "    ", "7abcdefghijklmn", "7abcdefghijklmn"}
    Public Test02Data07 As String() = {"2345675", "2345675", "    ", "234567890120", "234567890120", "    ", "8abcdefghijklmn", "8abcdefghijklmn"}
    Public Test02Data08 As String() = {"2345676", "2345676", "    ", "234567890121", "234567890121", "    ", "9abcdefghijklmn", "9abcdefghijklmn"}
    Public Test02Data09 As String() = {"2345677", "2345677", "    ", "234567890122", "234567890122", "    ", "0abcdefghijklmn", "0abcdefghijklmn"}
    Public Test02Data10 As String() = {"2345678", "2345678", "    ", "234567890123", "234567890123", "    ", "1abcdefghijklmn", "1abcdefghijklmn"}




End Class
