﻿'***********************************************************************
'【目的】TablePrintの列フォーマット書式を作成する。
'        版権：Fsoft  このソースは、弊社の共通モジュールです。版権は Fsoft にあります。他のプロジェクトへの流用は、ご遠慮下さい。 
'
'
'***********************************************************************

Public Class Frm列フォーマット作成

    Private Const c行Max As Integer = 15

    'Cmb列番号01
    'CmbDataType01
    'Chk合計01
    'Cmb少数桁数01
    '
    '
    '
    '
    '
    '
    '
    '
    '****************************************************************************************
    '
    '****************************************************************************************
    Private Sub Frm列フォーマット作成_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim ScreenWidth As Integer
        Dim ScreenHeight As Integer
        ScreenWidth = SystemInformation.WorkingArea.Width
        ScreenHeight = SystemInformation.WorkingArea.Height
        Me.Location = New Point((ScreenWidth - Me.Width) / 2, (ScreenHeight - Me.Height) / 2)
        '
        クリア()
    End Sub

    '****************************************************************************************
    '
    '****************************************************************************************
    Private Sub btn作成_Click(sender As System.Object, e As System.EventArgs) Handles btn作成.Click
        Dim ans As String = All列フォーマット作成()
        TxtAns.Text = ans
        Clipboard.SetText(ans)
    End Sub

    '****************************************************************************************
    '
    '****************************************************************************************
    Private Sub btn画面クリア_Click(sender As System.Object, e As System.EventArgs) Handles btn画面クリア.Click
        クリア()
    End Sub

    '****************************************************************************************
    '
    '****************************************************************************************
    Private Sub btn終了_Click(sender As System.Object, e As System.EventArgs) Handles btn終了.Click
        Me.Close()
    End Sub

    '****************************************************************************************
    '
    '****************************************************************************************
    Private Sub クリア()
        TxtAns.Text = ""

        For i = 0 To c行Max - 1
            pvCmb列番号(i).Text = ""
            pvCmbDataType(i).Text = ""
            pvChk合計(i).Checked = False
            pvCmb少数桁数(i).Text = "0"
        Next
    End Sub

    '****************************************************************************************
    '
    '****************************************************************************************
    Private Function All列フォーマット作成() As String
        Dim wkAns As String = ""
        For i = 0 To c行Max - 1
            wkAns &= 列フォーマット作成(i)
        Next
        wkAns = """" & atStrRightIsDell(wkAns.Trim, ",") & """"
        Return (wkAns)
    End Function


    '****************************************************************************************
    '
    '****************************************************************************************
    Private Function 列フォーマット作成(ByVal pLno As Integer) As String
        Dim wkAns As String = ""
        Dim wkStr As String = ""
        Dim tpStr As String = ""
        tpStr = pvCmb列番号(pLno).Text.Trim
        If tpStr = "" Then
            Return ("")
        End If
        wkStr = tpStr & "/"

        tpStr = pvCmbDataType(pLno).Text.ToUpper.Trim
        Select Case tpStr
            Case "文字"
                wkStr &= "S"
            Case "整数"
                wkStr &= "I/"
                If pvChk合計(pLno).Checked = True Then
                    wkStr &= "1"
                Else
                    wkStr &= "0"
                End If

            Case "通貨"
                wkStr &= "C/"
                If pvChk合計(pLno).Checked = True Then
                    wkStr &= "1/"
                Else
                    wkStr &= "0/"
                End If
                tpStr = pvCmb少数桁数(pLno).Text.ToUpper.Trim
                If tpStr = "" Then tpStr = "0"
                wkStr &= tpStr

            Case "日付"
                wkStr &= "D"

            Case "JAN8"
                wkStr &= "B8"

            Case "JAN13"
                wkStr &= "B13"

            Case "CODE39"
                wkStr &= "B39"

            Case "QRCODE"
                wkStr &= "QR"

            Case Else
                wkStr &= " "
        End Select

        Return (wkStr & ", ")
    End Function



    '****************************************************************************************
    '
    '****************************************************************************************
    Private Function pvCmb列番号(ByVal index As Integer) As ComboBox
        Return DirectCast(Me.Controls("Cmb列番号" & pvNo(index)), ComboBox)
    End Function

    Private Function pvCmbDataType(ByVal index As Integer) As ComboBox
        Return DirectCast(Me.Controls("CmbDataType" & pvNo(index)), ComboBox)
    End Function

    Private Function pvChk合計(ByVal index As Integer) As CheckBox
        Return DirectCast(Me.Controls("Chk合計" & pvNo(index)), CheckBox)
    End Function

    Private Function pvCmb少数桁数(ByVal index As Integer) As ComboBox
        Return DirectCast(Me.Controls("Cmb少数桁数" & pvNo(index)), ComboBox)
    End Function

    Private Function pvNo(ByVal pIndex As Integer) As String
        Return (atStrRight("00" & pIndex.ToString, 2))
    End Function


    '/========================================================================
    '/*----------------------------------------------------------------------*/
    '/*  後ろから n文字を返す。（右側からn文字取得）
    '/*  
    '/*  pSrc      ：変換元文字列  
    '/*  n         ：後ろからの取得文字数 n=1～
    '/*  
    '/*   例  "6" =  atStrRight("123456", 1)
    '/*  
    '/*  rt        ：変換結果  
    '/========================================================================
    Private Function atStrRight(ByVal pSrc As String, ByVal n As Integer) As String
        If n < 0 Then Return ("")

        If pSrc.Length < n Then
            Return (pSrc)
        Else
            Return (pSrc.Substring(pSrc.Length - n, n))
        End If
    End Function

    '/========================================================================
    '/*----------------------------------------------------------------------*/
    '/*  後ろが、指定された文字列だと、その文字列を取り去って、前方の文字列を返す。(後ろの \ 等を取り去る為に使用)
    '/*        注）比較は大文字、小文字を区別しない。
    '/*  
    '/*  pSrc      ：変換元文字列  
    '/*  pDls      ：後ろから取り去る文字列
    '/*  
    '/*   例  "12345" = atStrRightIsDell("12345\", "\")
    '/*  
    '/*  rt        ：変換結果  
    '/========================================================================
    Private Function atStrRightIsDell(ByVal pSrc As String, ByVal pDls As String) As String
        If atStrRight(pSrc, pDls.Length).ToUpper = pDls.ToUpper Then
            Return (atStrRightDell(pSrc, pDls.Length))
        Else
            Return (pSrc)
        End If
    End Function




    '/========================================================================
    '/*----------------------------------------------------------------------*/
    '/*  後ろから n文字を取り去った、前方の文字列を返す。
    '/*  
    '/*  pSrc      ：変換元文字列  
    '/*  n         ：後ろから取り去る文字数 n=1～
    '/*  
    '/*   例  "12345" = atStrRightDell("123456", 1)
    '/*  
    '/*  rt        ：変換結果  
    '/========================================================================
    Private Function atStrRightDell(ByVal pSrc As String, ByVal n As Integer) As String
        If n < 0 Then Return (pSrc)
        If pSrc.Length < n Then
            Return ("")
        Else
            Return (pSrc.Substring(0, pSrc.Length - n))
        End If
    End Function









End Class